<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->
<admin-edit-view>

  <mat-card id="electoralAuthorityKeyEdit" class="parameter-edit" [class.read-only]="readOnly">
    <mat-card-header>
      <mat-card-title>{{'admin.electoral-authority-key.edit.title' | translate}}</mat-card-title>
      <mat-card-subtitle fxLayout="row" fxLayoutAlign="space-between">
        <span>{{'admin.electoral-authority-key.edit.subtitle' | translate}}</span>
        <span *ngIf="!readOnly">{{'global.forms.fields.required' | translate}}</span>
      </mat-card-subtitle>
    </mat-card-header>
    <mat-card-content class="no-padding">


      <ng-container *roles="['ADD_ELECTORAL_AUTHORITY_KEY']">
        <div fxLayout fxLayoutGap="25px" class="parameter-input" id="electoralAuthorityKeyInputBox" *ngIf="!readOnly">
          <form [formGroup]="importForm" novalidate>
            <div fxLayout fxLayoutGap="25px">
              <mat-form-field class="form-field-label">
                <input matInput name="label" formControlName="label"
                       placeholder="{{'admin.electoral-authority-key.edit.form.fields.label.placeholder' | translate}}"
                       maxlength="200" required>
                <mat-error>
                  <default-errors [fieldName]="'label'" [form]="importForm"></default-errors>
                </mat-error>
              </mat-form-field>
            </div>
          </form>

          <upload-input fxFlex="auto"
                        placeholder="admin.electoral-authority-key.edit.form.fields.input-file.placeholder"
                        [uploadUrl]="uploadUrl"
                        fileAccept=".json"
                        uploadIcon="file_upload"
                        uploadText="global.actions.import"
                        progressText="global.upload-progress"
                        [checkBeforeUpload]="checkBeforeUpload()"
                        (uploadDone)="processUploadResult($event)">
          </upload-input>
        </div>
      </ng-container>


      <mat-table [hidden]="keys.length === 0" [dataSource]="dataSource" matSort id="electoralAuthorityKeyList">


        <ng-container matColumnDef="label">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"admin.electoral-authority-key.edit.table.header.label" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <text-with-edit [text]="element.label" [disabled]="readOnly" (edit)="editLabel(element)"></text-with-edit>
          </mat-cell>
        </ng-container>


        <ng-container matColumnDef="keyHash">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"admin.electoral-authority-key.edit.table.header.keyHash" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            {{element.keyHash}}
          </mat-cell>
        </ng-container>

        <ng-container matColumnDef="importDate">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"admin.electoral-authority-key.edit.table.header.importDate" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <div>
              {{element.importDate | date:'dd.MM.yyyy'}}
            </div>
          </mat-cell>
        </ng-container>

        <ng-container matColumnDef="login">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"admin.electoral-authority-key.edit.table.header.login" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <div>
              {{element.login}}
            </div>
          </mat-cell>
        </ng-container>


        <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
        <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
      </mat-table>

    </mat-card-content>
  </mat-card>
</admin-edit-view>
